Subject: [CCAMP] FW: New Version Notification for draft-jiang-ccamp-flexe-yang-00.txt

From: Jiangyuanlong <[email-masked]>
Date: Mon, 4 Mar 2019 08:43:47 +0000

Dear CCAMPers,

More and more network equipments (e.g., routers) begin to support FlexE interfaces in the industry, especially after OIF published its FlexE 2.0 implementation agreement.
We submitted an I-D on "YANG Data Model for FlexE Interface Management", to support configuration of FlexE 2.0 interface like an ordinary network interface (by augmenting the YANG module of RFC 8343).
Your reviews and comments will be very appreciated. 

Best regards,
Yuanlong on behalf of all coauthors

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] 
Sent: Friday, March 01, 2019 4:48 PM
To: Weiqiang Cheng <[email-masked]>; Jiangyuanlong <[email-masked]>; Hexiang (Xiang, IP Research) <[email-masked]>
Subject: New Version Notification for draft-jiang-ccamp-flexe-yang-00.txt

A new version of I-D, draft-jiang-ccamp-flexe-yang-00.txt
has been successfully submitted by Yuanlong Jiang and posted to the IETF repository.

Name:		draft-jiang-ccamp-flexe-yang
Revision:	00
Title:		YANG Data Model for FlexE Interface Management
Document date:	2019-03-01
Group:		Individual Submission
Pages:		15
URL:            https://www.ietf.org/internet-drafts/draft-jiang-ccamp-flexe-yang-00.txt
Status:         https://datatracker.ietf.org/doc/draft-jiang-ccamp-flexe-yang/
Htmlized:       https://tools.ietf.org/html/draft-jiang-ccamp-flexe-yang-00
Htmlized:       https://datatracker.ietf.org/doc/html/draft-jiang-ccamp-flexe-yang

Abstract:
   This document defines a YANG data model for the configuration of
   FlexE 2.0 interface, and its FlexE clients. The YANG module in this
   document conforms to the Network Management Datastore Architecture
   (NMDA).

Please note that it may take a couple of minutes from the time of submission until the htmlized version and diff are available at tools.ietf.org.

The IETF Secretariat

---

From: tom petch <[email-masked]>
Date: Tue, 5 Mar 2019 10:23:11 +0000

----- Original Message -----
From: "Jiangyuanlong" <[email-masked]>
Sent: Monday, March 04, 2019 8:43 AM

> Dear CCAMPers,
>
> More and more network equipments (e.g., routers) begin to support
FlexE interfaces in the industry, especially after OIF published its
FlexE 2.0 implementation agreement.
> We submitted an I-D on "YANG Data Model for FlexE Interface
Management", to support configuration of FlexE 2.0 interface like an
ordinary network interface (by augmenting the YANG module of RFC 8343).
> Your reviews and comments will be very appreciated.

The challenge with such an I-D is getting access to the documentation of
another SDO to see just what it says, in this case, that of the OIF,
which some on this list will have but I assume that I will not.  Thus it
would be interesting to learn more about the relationship between

"            Note that max number of FlexE groups in a network is 63.";
and
"         leaf group-number { type uint32 {  range "1..1048574";

More prosaically, the IANA Considerations need work.  You say
"   It is proposed that IANA register a new IANAifType TBD for
   the interface type of Flex Ethernet in the "IANA Interface Type
   YANG Module" [RFC7224]."

Go read RFC7224 and you will find it says that this MUST NOT happen:-)
Rather, RFC7224 says that you should request IANA to
add a new interface type to the "ifType definitions" registry, whereupon
IANA will do the rest.  And RFC7224 specifies what data should be
specified with such a request which this I-D does not, at present,
provide.

Thus the YANG module has
       when "if:type = 'ianaift:flexethernet'" {
but 'flexethernet' is not defined anywhere so will never exist!

And
" It is proposed that IANA register the following YANG module in the
   "YANG Module Names" registry:
   Name:         ietf-flexe
   Namespace:    urn:ietf:params:xml:ns:yang:ietf-flexe
   Prefix:       flexe
   Reference:    this document"
will not work either; in the IANA web pages, 'this document' will not
make much sense - rather, you need RFC XXXX with a note to the RFC
Editor for XXXX to be replaced with the number assigned to the I-D.  You
need just the same in the YANG module itself.  (You only need the one
Note to the RFC Editor at the front of the I-D - the RFC Editor tell me
they prefer this).

Registering the YANG module needs a reference to RFC6020.

More technically, the use of enumerations in YANG is problematic since
- the numeric value is not carried in the protocol, it is for
documentation only (unlike SMI)
- it is complex to add values in future which I imagine will happen with
FlexE

Hence the widespread use of the YANG identity statement, which also has
its problems.  enumeration may be the right answer but it needs
consideration.

Tom Petch

> To: Weiqiang Cheng <[email-masked]>; Jiangyuanlong
<[email-masked]>; Hexiang (Xiang, IP Research)
<[email-masked]>
> URL:
https://www.ietf.org/internet-drafts/draft-jiang-ccamp-flexe-yang-00.txt
> Status:
https://datatracker.ietf.org/doc/draft-jiang-ccamp-flexe-yang/
> Htmlized:
https://tools.ietf.org/html/draft-jiang-ccamp-flexe-yang-00
> Htmlized:
https://datatracker.ietf.org/doc/html/draft-jiang-ccamp-flexe-yang
> Please note that it may take a couple of minutes from the time of
submission until the htmlized version and diff are available at
tools.ietf.org.
>
> The IETF Secretariat
>
> _______________________________________________
> CCAMP mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ccamp

---

From: Loa Andersson <[email-masked]>
Date: Tue, 5 Mar 2019 19:21:22 +0800

Tom,

FWIW on the OIF webpage there is a pull down menu, first choice is
Implementation Agreements. On that page you'll find
https://www.oiforum.com/wp-content/uploads/2019/01/OIF-FLEXE-02.0-1.pdf

If I understand the intent correct it should be self-contained.

/Loa

-- 

Loa Andersson                        email: [email-masked]
Senior MPLS Expert
Bronze Dragon Consulting             phone: +46 739 81 21 64

---

From: Jiangyuanlong <[email-masked]>
Date: Fri, 8 Mar 2019 07:52:45 +0000

Dear Tom,

Thank you a lot for your review and comments. This I-D is still an initial version of individual draft, so it need further work and we are glad to see more reviews and suggestions.
Please see my further comments inline.

Best regards,
Yuanlong

-----Original Message-----
From: tom petch [mailto:[email-masked]] 
Sent: Tuesday, March 05, 2019 6:23 PM
To: Jiangyuanlong <[email-masked]>; 'CCAMP' <[email-masked]>
Cc: Weiqiang Cheng <[email-masked]>; Hexiang (Xiang, IP Research) <[email-masked]>
Subject: Re: [CCAMP] FW: New Version Notification for draft-jiang-ccamp-flexe-yang-00.txt

----- Original Message -----
From: "Jiangyuanlong" <[email-masked]>
Sent: Monday, March 04, 2019 8:43 AM

> More and more network equipments (e.g., routers) begin to support
FlexE interfaces in the industry, especially after OIF published its FlexE 2.0 implementation agreement.
> We submitted an I-D on "YANG Data Model for FlexE Interface
Management", to support configuration of FlexE 2.0 interface like an ordinary network interface (by augmenting the YANG module of RFC 8343).
> Your reviews and comments will be very appreciated.

The challenge with such an I-D is getting access to the documentation of another SDO to see just what it says, in this case, that of the OIF, which some on this list will have but I assume that I will not.  Thus it would be interesting to learn more about the relationship between

[JYL]: Just as Loa's email indicated, you can access FlexE 2.0 document by: https://www.oiforum.com/wp-content/uploads/2019/01/OIF-FLEXE-02.0-1.pdf

Go read RFC7224 and you will find it says that this MUST NOT happen:-) Rather, RFC7224 says that you should request IANA to add a new interface type to the "ifType definitions" registry, whereupon IANA will do the rest.  And RFC7224 specifies what data should be specified with such a request which this I-D does not, at present, provide.
[JYL]: My interpretation is RFC 7224 gives the information on IANA Interface Type YANG Module. You are right that the RFC don't need to change every time a new ifType is specified.

Thus the YANG module has
       when "if:type = 'ianaift:flexethernet'" { but 'flexethernet' is not defined anywhere so will never exist!

And
" It is proposed that IANA register the following YANG module in the
   "YANG Module Names" registry:
   Name:         ietf-flexe
   Namespace:    urn:ietf:params:xml:ns:yang:ietf-flexe
   Prefix:       flexe
   Reference:    this document"
will not work either; in the IANA web pages, 'this document' will not make much sense - rather, you need RFC XXXX with a note to the RFC Editor for XXXX to be replaced with the number assigned to the I-D.  You need just the same in the YANG module itself.  (You only need the one Note to the RFC Editor at the front of the I-D - the RFC Editor tell me they prefer this).
[JYL]: Good advice, though I used to think such a note will be more rightful when this drat is well accepted by the WG and has the WG's consensus. 

Registering the YANG module needs a reference to RFC6020.
[JYL]: Good observation. Actually I think this is somewhat similar to the previous ifType issue, do we really need to refer to RFC 6020 while it cannot be changed?

More technically, the use of enumerations in YANG is problematic since
- the numeric value is not carried in the protocol, it is for documentation only (unlike SMI)
[JYL]: Do you mean the FlexE protocol itself? I think when we define a value in the YANG module, then the value is in the standard.

- it is complex to add values in future which I imagine will happen with FlexE
[JYL]: Not sure I understand your concern, do you mean that it is difficult thing to add some new values into an enumeration type? 

Hence the widespread use of the YANG identity statement, which also has its problems.  enumeration may be the right answer but it needs consideration.

Tom Petch

> To: Weiqiang Cheng <[email-masked]>; Jiangyuanlong
<[email-masked]>; Hexiang (Xiang, IP Research) <[email-masked]>
> Title: YANG Data Model for FlexE Interface Management Document date: 
> 2019-03-01
> Please note that it may take a couple of minutes from the time of
submission until the htmlized version and diff are available at tools.ietf.org.

---

From: tom petch <[email-masked]>
Date: Fri, 8 Mar 2019 11:59:56 +0000

----- Original Message -----
From: "Loa Andersson" <[email-masked]>
Sent: Tuesday, March 05, 2019 11:21 AM

> If I understand the intent correct it should be self-contained.

Thanks for that; I have downloaded it and will peruse it.  It has
Normative references to IEEE 802.3 and two ITU-T G., nothing unexpected.

I suggest adding the URL to the I-D.

Tom Petch